var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as VueDemi from 'vue-demi';
import { createModuleLoader } from './core/moduleLoader';
import { createComponentLoader } from './core/componentLoader';
import { ModuleLoaderSymbol, setActiveLoader, setOptions, addErrorHandler, removeErrorHandler } from './register';
import { createUmdResolver } from './resolvers/umd';
/**
 * create module loader
 */
export function createLoader(options) {
    if (options === void 0) { options = {}; }
    var resolver = options.resolver, resolverOptions = __rest(options, ["resolver"]);
    var _resolver = resolver
        ? typeof resolver === 'function'
            ? resolver(resolverOptions)
            : resolver
        : createUmdResolver(resolverOptions);
    var loader = VueDemi.markRaw({
        install: function (app) {
            // this allows calling registerSubModules() outside of a component setup after
            setActiveLoader(loader);
            if (!VueDemi.isVue2) {
                var moduleLoader = createModuleLoader(app, _resolver);
                var componentLoader = createComponentLoader(app, _resolver);
                loader._a = app;
                loader._moduleLoader = moduleLoader;
                loader._componentLoader = componentLoader;
                app.config.globalProperties.$moduleLoader = loader;
                app.provide(ModuleLoaderSymbol, loader);
            }
        },
        setOptions: function (options) {
            setOptions.call(null, options);
            return this;
        },
        addErrorHandler: function (handler) {
            addErrorHandler.call(null, handler);
            return this;
        },
        removeErrorHandler: function (handler) {
            removeErrorHandler.call(null, handler);
            return this;
        },
        resolver: Object.freeze(_resolver),
        // it's actually undefined here
        // @ts-expect-error set in install when using Vue 3
        _a: null,
        // @ts-expect-error set in install when using Vue 3
        _moduleLoader: null,
        // @ts-expect-error set in install when using Vue 3
        _componentLoader: null,
    });
    return loader;
}
